From 55700cb8c1396f1ae88f69f219cf2cc0dfe515d5 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Sun, 10 Apr 2022 16:33:55 +0800
Subject: [PATCH] Add openssl build.sh

---
 3rdparty/x86/openssl/build.sh |  104 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 104 insertions(+), 0 deletions(-)

diff --git a/3rdparty/x86/openssl/build.sh b/3rdparty/x86/openssl/build.sh
new file mode 100755
index 0000000..3237910
--- /dev/null
+++ b/3rdparty/x86/openssl/build.sh
@@ -0,0 +1,104 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile openssl for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+JOBS=`cat /proc/cpuinfo |grep "processor"|wc -l`
+
+PRJ_PATH=`pwd`
+PREFIX_PATH=`pwd`/../install
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=arm-linux-gnueabihf-
+
+# display in red
+function pr_error() {
+    echo -e "\033[40;31m --E-- $1 \033[0m"
+}
+
+# display in yellow
+function pr_warn() {
+    echo -e "\033[40;33m --W-- $1 \033[0m"
+}
+
+# display in green
+function pr_info() {
+    echo -e "\033[40;32m --I-- $1 \033[0m"
+}
+
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo -e "|\033[40;33m  $1 \033[0m"
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+        pr_error $1
+    fi  
+}
+
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+function compile_openssl()
+{
+    SRC_NAME=openssl-1.1.1n
+    PACK_SUFIX=tar.gz 
+
+    if [ -f ${PREFIX_PATH}/lib/libcrypto.a ] ; then 
+		msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi  
+    
+    msg_banner "Start cross compile $SRC_NAME " 
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then 
+        #wget https://www.openssl.org/source/${SRC_NAME}.${PACK_SUFIX} 
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi  
+
+    tar -xzf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME} 
+    
+    CROSS_COMPILE=${CROSSTOOL} CFLAGS=-I${PRJ_PATH}/cryptodev-linux ./Configure \
+        threads -shared -no-zlib --prefix=$PREFIX_PATH --openssldir=$PREFIX_PATH \
+        linux-armv4
+
+    make -j ${JOBS} && make install 
+    check_result "ERROR: compile ${SRC_NAME} failure" 
+
+    cd - 
+} 
+
+compile_openssl
+
+

--
Gitblit v1.9.1